diff --git a/src/include/nodes/pathnodes.h b/src/include/nodes/pathnodes.h
index 5ff40ef..72b7f96 100644
--- a/src/include/nodes/pathnodes.h
+++ b/src/include/nodes/pathnodes.h
@@ -81,18 +81,6 @@ typedef enum UpperRelationKind
 	/* NB: UPPERREL_FINAL must be last enum entry; it's used to size arrays */
 } UpperRelationKind;
 
-/*
- * This enum identifies which type of relation is being planned through the
- * inheritance planner.  INHKIND_NONE indicates the inheritance planner
- * was not used.
- */
-typedef enum InheritanceKind
-{
-	INHKIND_NONE,
-	INHKIND_INHERITED,
-	INHKIND_PARTITIONED
-} InheritanceKind;
-
 /*----------
  * PlannerGlobal
  *		Global information for planning/optimization
@@ -219,6 +207,14 @@ struct PlannerInfo
 	struct AppendRelInfo **append_rel_array;
 
 	/*
+	 * Same length as other "simple" rel arrays and holds pointers to
+	 * InheritResultRelInfo for this subquery's result relations indexed by
+	 * RT index, or NULL if the rel is not a result relation.  The array is not
+	 * allocated unless the query is an inherited UPDATE/DELETE.
+	 */
+	struct InheritResultRelInfo **inherit_result_rel_array;
+
+	/*
 	 * all_baserels is a Relids set of all base relids (but not "other"
 	 * relids) in the query; that is, the Relids identifier of the final join
 	 * we need to form.  This is computed in make_one_rel, just before we
@@ -289,6 +285,8 @@ struct PlannerInfo
 	 */
 	List	   *append_rel_list;	/* list of AppendRelInfos */
 
+	List	   *inherit_result_rels;	/* List of InheritResultRelInfo */
+
 	List	   *rowMarks;		/* list of PlanRowMarks */
 
 	List	   *placeholder_list;	/* list of PlaceHolderInfos */
@@ -331,6 +329,9 @@ struct PlannerInfo
 	 */
 	List	   *update_tlist;
 
+	/* Scratch space for inherit.c: add_inherit_junk_var() */
+	List	   *inherit_junk_tlist;	/* List of TargetEntry */
+
 	/* Fields filled during create_plan() for use in setrefs.c */
 	AttrNumber *grouping_map;	/* for GroupingFunc fixup */
 	List	   *minmax_aggs;	/* List of MinMaxAggInfos */
@@ -346,9 +347,6 @@ struct PlannerInfo
 	Index		qual_security_level;	/* minimum security_level for quals */
 	/* Note: qual_security_level is zero if there are no securityQuals */
 
-	InheritanceKind inhTargetKind;	/* indicates if the target relation is an
-									 * inheritance child or partition or a
-									 * partitioned table */
 	bool		hasJoinRTEs;	/* true if any RTEs are RTE_JOIN kind */
 	bool		hasLateralRTEs; /* true if any RTEs are marked LATERAL */
 	bool		hasHavingQual;	/* true if havingQual was non-null */
@@ -369,6 +367,9 @@ struct PlannerInfo
 
 	/* Does this query modify any partition key columns? */
 	bool		partColsUpdated;
+
+	/* Highest result relation index assigned in this subquery */
+	int			lastResultRelIndex;
 };
 
 
@@ -2265,6 +2266,13 @@ typedef struct AppendRelInfo
 	List	   *translated_vars;	/* Expressions in the child's Vars */
 
 	/*
+	 * The following contains expressions that the child relation is expected
+	 * to output for each "fake" parent Var that add_inherit_junk_var() adds
+	 * to the parent's reltarget; also see translate_fake_parent_var().
+	 */
+	List	   *translated_fake_vars;
+
+	/*
 	 * This array simplifies translations in the reverse direction, from
 	 * child's column numbers to parent's.  The entry at [ccolno - 1] is the
 	 * 1-based parent column number for child column ccolno, or zero if that
@@ -2282,6 +2290,41 @@ typedef struct AppendRelInfo
 } AppendRelInfo;
 
 /*
+ * InheritResultRelInfo
+ *		Information about result relations of an inherited UPDATE/DELETE
+ *		operation
+ *
+ * If the main target relation is an inheritance parent, we build an
+ * InheritResultRelInfo for it and for every child result relation resulting
+ * from expanding it.  This is to store the information relevant to each
+ * result relation that must be added to the ModifyTable, such as its update
+ * targetlist, WITH CHECK OPTIONS, and RETURNING expression lists.  For the
+ * main result relation (root inheritance parent), that information is same
+ * as what's in Query and PlannerInfo.  For child result relations, we make
+ * copies of those expressions with appropriate translation of any Vars.
+ * Also, update_tlist for a given child relation has been made such that
+ * resnos of the TLEs contained in it match the child relation attribute
+ * numbers.
+ *
+ * While it's okay for the code outside of the core planner to look at
+ * update_tlist, processed_tlist is only kept around for internal planner use.
+ * For example, an FDW's PlanDirectModify() may look at update_tlist to check
+ * if the assigned expressions are pushable.
+ */
+typedef struct InheritResultRelInfo
+{
+	NodeTag		type;
+
+	Index		resultRelation;
+	List	   *withCheckOptions;
+	List	   *returningList;
+
+	/* Only valid for UPDATE. */
+	List	   *processed_tlist;
+	List	   *update_tlist;
+} InheritResultRelInfo;
+
+/*
  * For each distinct placeholder expression generated during planning, we
  * store a PlaceHolderInfo node in the PlannerInfo node's placeholder_list.
  * This stores info that is needed centrally rather than in each copy of the
diff --git a/src/include/nodes/plannodes.h b/src/include/nodes/plannodes.h
index fba746e..bdb91b3 100644
--- a/src/include/nodes/plannodes.h
+++ b/src/include/nodes/plannodes.h
@@ -202,7 +202,7 @@ typedef struct ProjectSet
 
 /* ----------------
  *	 ModifyTable node -
- *		Apply rows produced by subplan(s) to result table(s),
+ *		Apply rows produced by subplan to result table(s),
  *		by inserting, updating, or deleting.
  *
  * If the originally named target table is a partitioned table, both
@@ -226,7 +226,7 @@ typedef struct ModifyTable
 	List	   *resultRelations;	/* integer list of RT indexes */
 	int			resultRelIndex; /* index of first resultRel in plan's list */
 	int			rootResultRelIndex; /* index of the partitioned table root */
-	List	   *plans;			/* plan(s) producing source data */
+	Plan	   *subplan;		/* plan producing source data */
 	List	   *withCheckOptionLists;	/* per-target-table WCO lists */
 	List	   *returningLists; /* per-target-table RETURNING tlists */
 	List	   *updateTargetLists;	/* per-target-table UPDATE tlists */
diff --git a/src/include/nodes/primnodes.h b/src/include/nodes/primnodes.h
index d73be2a..5d43cf6 100644
--- a/src/include/nodes/primnodes.h
+++ b/src/include/nodes/primnodes.h
@@ -1362,13 +1362,15 @@ typedef struct InferenceElem
  * column for the item; so there may be missing or out-of-order resnos.
  * It is even legal to have duplicated resnos; consider
  *		UPDATE table SET arraycol[1] = ..., arraycol[2] = ..., ...
- * The two meanings come together in the executor, because the planner
- * transforms INSERT/UPDATE tlists into a normalized form with exactly
- * one entry for each column of the destination table.  Before that's
- * happened, however, it is risky to assume that resno == position.
- * Generally get_tle_by_resno() should be used rather than list_nth()
- * to fetch tlist entries by resno, and only in SELECT should you assume
- * that resno is a unique identifier.
+ * For INSERT, the planner normalizes the tlist by filling in NULL constants
+ * for any columns not assigned values in the original tlist.  For UPDATE, the
+ * possibility of multiple destination relations due to inheritance means that
+ * there’s no one unique set of attribute numbers to normalize the tlist with,
+ * so it’s left unchanged except reordering the items in to appear in root
+ * table's attribute numbers.  Given these irregularities, it is risky to
+ * assume that resno == position.  Generally get_tle_by_resno() should be used
+ * rather than list_nth() to fetch tlist entries by resno, and only in SELECT
+ * should you assume that resno is a unique identifier.
  *
  * resname is required to represent the correct column name in non-resjunk
  * entries of top-level SELECT targetlists, since it will be used as the
diff --git a/src/include/optimizer/appendinfo.h b/src/include/optimizer/appendinfo.h
index d6a27a6..08454ba 100644
--- a/src/include/optimizer/appendinfo.h
+++ b/src/include/optimizer/appendinfo.h
@@ -22,6 +22,8 @@ extern AppendRelInfo *make_append_rel_info(Relation parentrel,
 										   Index parentRTindex, Index childRTindex);
 extern Node *adjust_appendrel_attrs(PlannerInfo *root, Node *node,
 									int nappinfos, AppendRelInfo **appinfos);
+extern Node *adjust_target_appendrel_attrs(PlannerInfo *root, Node *node,
+									AppendRelInfo *appinfo);
 extern Node *adjust_appendrel_attrs_multilevel(PlannerInfo *root, Node *node,
 											   Relids child_relids,
 											   Relids top_parent_relids);
@@ -31,5 +33,6 @@ extern Relids adjust_child_relids_multilevel(PlannerInfo *root, Relids relids,
 											 Relids child_relids, Relids top_parent_relids);
 extern AppendRelInfo **find_appinfos_by_relids(PlannerInfo *root,
 											   Relids relids, int *nappinfos);
+extern Node *translate_fake_parent_var(Var *var, AppendRelInfo *appinfo);
 
 #endif							/* APPENDINFO_H */
diff --git a/src/include/optimizer/planmain.h b/src/include/optimizer/planmain.h
index f3cefe6..117efe4 100644
--- a/src/include/optimizer/planmain.h
+++ b/src/include/optimizer/planmain.h
@@ -115,4 +115,10 @@ extern void record_plan_function_dependency(PlannerInfo *root, Oid funcid);
 extern void record_plan_type_dependency(PlannerInfo *root, Oid typid);
 extern bool extract_query_dependencies_walker(Node *node, PlannerInfo *root);
 
+/*
+ * prototype for plan/planner.c
+ */
+extern bool is_result_relation(Index relid, PlannerInfo *root);
+extern List *get_result_update_tlist(PlannerInfo *root, Index result_relation);
+
 #endif							/* PLANMAIN_H */
diff --git a/src/include/optimizer/prep.h b/src/include/optimizer/prep.h
index 19c9230..01e5c54 100644
--- a/src/include/optimizer/prep.h
+++ b/src/include/optimizer/prep.h
@@ -16,6 +16,7 @@
 
 #include "nodes/pathnodes.h"
 #include "nodes/plannodes.h"
+#include "utils/relcache.h"
 
 
 /*
@@ -35,6 +36,7 @@ extern Relids get_relids_for_join(Query *query, int joinrelid);
  * prototypes for preptlist.c
  */
 extern List *preprocess_targetlist(PlannerInfo *root);
+extern List *make_update_tlist(List *tlist, Index result_relation, Relation rel);
 
 extern PlanRowMark *get_plan_rowmark(List *rowmarks, Index rtindex);
 
